/* ---- (c) SETA DOMINIO PUBLICO ---- */
/* ---- LINUX  ---------- */
/* ---- MODIFICADO EL 24-09-1998 ----- */
/* ---- MODO-10- 640x480x256 COLORES LIBSVGA ---- */


#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "time.h"
#include "vga.h"
#include "vgagl.h"

/* ---- RUTINAS CON BAJO NIVEL ---- */

int dmode(void);

void mode(int mode_code);

void clear(unsigned char c);

void plot(int x,int y);

int point(int x,int y);

void line(int x,int y,int xx,int yy);

void bar(int x,int y,int xx,int yy);

void impri (int x,int y,unsigned char ca);

void loadfont(char *nombre);

void loadpcx(char *nombre);

void mouse(int x);

void mouses(int x,int y,int t);

void paleta();

void paletapal();

void paletablock(int n);

void velocidad(void);

void espera(int s);
void waits(int s);
unsigned int Ctime(void);

void sonido(unsigned int frecuencia,unsigned int duracion);

void Sbeep(unsigned short high);

void getblock(int n,int x,int y,int ancho,int alto);
void putblock(int n,int x,int y);
void loadblock(int n,char *nombre);
void putz(int n,long xd,long yd,long xs,long ys, long xx, long yy);

void getz(int n,long xd,long yd,long xs,long ys, long xx, long yy);

void fade(int num);

void getcolors(void);

int inkey(void);
int inkey2(void);
void newbank(char ban);
unsigned char inportb(unsigned short port);
void outportb(unsigned short port, unsigned char value);

/* -------------------------------- */


/* ---- RUTINAS NORMALES ----- */
void inputc(int x,int y,char *nombre);
long inputn(int x,int y,char *nombre);
void box(int x,int y,int xx,int yy);
void printc(int x,int y,char *texto);
void printn(int x,int y,long num);
void error(int z);
/* --------------------------- */

 
int INK=9,PAPER=1,SPEED,SETIM=1;
int XMOUSE,YMOUSE,KMOUSE,CMOUSE;
int MXz, MYz, MKz;
int IMOUSE=7,PMOUSE=0;
int BANCO,FONTX=1,FONTY=1,CX=0,CY=0;
int MOUSE=1;
FILE *pf;
char VARI[80];
int *VARI0;

unsigned char  *pv,*pv1,*pvx,*pvm;
unsigned int  *pvi,*pvi1,*pvxi,*pvmi;
unsigned char tabla[2040],pal[800],COLOR[16];

unsigned char tleta[48]= {0,0,0,63,63,63,

			  0,63,63,63,0,63,

			  0,0,63,63,63,0,

			  0,63,0,63,0,0,

			  32,32,32,48,48,48,
			  0,47,47,47,0,47,

			  0,0,47,47,47,0,

			  0,47,0,47,0,0

			  };

unsigned char *grafi[16];
unsigned char *grafip[16];
unsigned char tmouse[160]=
	{
	 0,0,3,3,3,3,3,3,3,3,
	 0,1,0,3,3,3,3,3,3,3,
	 0,1,1,0,3,3,3,3,3,3,
	 0,1,1,1,0,3,3,3,3,3,
	 0,1,1,1,1,0,3,3,3,3,
	 0,1,1,1,1,1,0,3,3,3,
	 0,1,1,1,1,1,1,0,3,3,
	 0,1,1,1,1,1,1,1,0,3,
	 0,1,1,1,1,1,1,1,1,0,
	 0,1,1,1,1,1,0,0,0,0,
	 0,1,1,0,1,1,0,3,3,3,
	 0,1,0,3,0,1,1,0,3,3,
	 0,0,3,3,0,1,1,0,3,3,
	 3,3,3,3,3,0,1,1,0,3,
	 3,3,3,3,3,0,1,1,0,3,
	 3,3,3,3,3,3,0,0,0,3

	};

unsigned char xmouse[160];

unsigned char sfteclado,agteclado,nuteclado,bmteclado;
unsigned char m0teclado[128] ={
0,27,'1','2','3','4','5','6','7','8','9',
'0',39,173,8,10,'q','w','e','r','t',
'y','u','i','o','p',96,'+',13,0,
'a','s','d','f','g','h','j','k','l',164,39,167,
0,135,'z','x','c','v','b','n','m',44,'.','-',0,
'*',0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,'7','8','9','-',
'4','5','6','+','1','2','3','0','.',0,0,60,
0,0,0,0,0,0,0,0,0,13,0,47,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

unsigned char m1teclado[128] ={
0,27,33,'"',250,'$','%','&','/','(',')',
'=','?',168,8,10,'Q','W','E','R','T',
'Y','U','I','O','P','^','*',13,0,
'A','S','D','F','G','H','J','K','L',165,34,166,
0,128,'Z','X','C','V','B','N','M',';',':','_',0,
'*',0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,'7','8','9','-',
'4','5','6','+','1','2','3','0','.',0,0,62,
0,0,0,0,0,0,0,0,0,13,0,47,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };


unsigned char m2teclado[128] ={
0,27,'|','@','#','4','5',191,'7','8','9',
'0',39,140,8,10,'q','w','e','r','t',
'y','u','i','o','p',96,'+',13,0,
'a','s','d','f','g','h','j','k','l',164,123,92,
0,125,'z','x','c','v','b','n','m',44,'.','-',0,
'*',0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'-',
0,0,0,'+',0,0,0,0,0,0,0,60,
0,0,0,0,0,0,0,0,0,13,0,47,
0,0,0,71,72,73,75,77,79,80,81,82,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };







/* ---------------------- SETA G640x480x256 ------------------------- */
/* -------------------------------------------------------- */
void sonido(unsigned int frecuencia,unsigned int duracion)
{
 Sbeep(frecuencia);
 espera(duracion);
 Sbeep(0);
}

unsigned char inportb(unsigned short port)
{
unsigned char z;
	__asm__("
	  pushw %%dx\n
	  pushw %%ax\n
	  movw %1,%%dx\n
	  in %%dx,%%al\n
	  movb %%al,%0\n
	  popw %%ax\n
	  popw %%dx"
	  : "=g" (z)
	  :  "g" (port)
	  : "ax","dx"
	);
	return(z);
}

void outportb(unsigned short port, unsigned char value)
{
	__asm__("
	  pushw %%dx\n
	  pushw %%ax\n
	  movw %1,%%dx\n
	  movb %0,%%al\n
	  out %%al,%%dx\n
	  popw %%ax\n
	  popw %%dx"
	  :
	  : "g" (value), "g" (port)
	  : "ax","dx"
	);
} 

void Sbeep(unsigned short high)
{
unsigned char p,cl,ch;

	cl=high & 0x00FF;

	ch=(high>>8) & 0x00FF;

	p = inportb(0x61);
 
	if(high)

		{

		 outportb(0x61,p|3);

		 outportb(0x43,0xb6);

		 outportb(0x42,cl);

		 outportb(0x42,ch);

		}

	 else

		{

		 outportb(0x61,p&0xfc);

		}
}


/* ---- espera un tiempo calculado en 25 cada segundo ---- */
void espera(int s)
{
int z;
	z=s*4;
	z+=(Ctime());
	if(z-Ctime()>250) goto fin;
 	while(Ctime()<z);
fin:
}



/* banco de SVGA */
void newbank(char ban)
{
	BANCO=ban;
	vga_setpage(ban);
}

/* --- 1=IMPRIME MOUSE    2=LEE MASCARA    3=ESCRIBE MASCARA --- */
void mouses (int x,int y,int t)
{
int d;
unsigned char c;
unsigned short int z,zz,z1,tt;

 if(MOUSE!=0)
  {
   d=y*640+x;
   z1=d;
   z=(d>>16)&0x0007;
   if(BANCO!=z)newbank(z);
   pv=pvx+z1;
   tt=0xFFFF-z1;
   zz=0;
   switch(t){
	case 1:
		for (z=0;z<160;z++)
		{
		 c=tmouse[z];
		 if(c!=3)if(c==0) *pv=PMOUSE; else *pv=IMOUSE;
		 pv++; zz++;
		 if(zz==10)
			{
			 pv+=630; zz=0;
			 if(tt<630){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
			 tt-=630;
			 if(tt<1){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
			}
		 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
		 tt--;
		}
		break;
	case 2:
		for (z=0;z<160;z++)
		{
		 xmouse[z]=*pv;
		 pv++; zz++;
		 if(zz==10)
			{
			 pv+=630; zz=0;
			 if(tt<630){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
			 tt-=630;
			 if(tt<1){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
			}
		 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
		 tt--;
		}
		break;
	case 3:
		for (z=0;z<160;z++)
		{
		*pv=xmouse[z];
		 pv++; zz++;
		 if(zz==10)
			{
			 pv+=630; zz=0;
			 if(tt<630){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
			 tt-=630;
			 if(tt<1){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
			}
		 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx+(pv-pvm)-1;}
		 tt--;
		}
		break;
	}
 }
}
/* ---- dibuja un rectangulo rellenandolo ---- */
void bar(int x,int y,int xx,int yy)
{
int  d,d2;
unsigned short int c,cc,z,z1,zz,tt;
unsigned char *base;
int ancho,alto;
  if(x>xx){d=x; x=xx; xx=d;}
  if(y>yy){d=y; y=yy; yy=d;}
  if(x<0)x=0;
  if(xx<0)xx=0;
  if(y<0)y=0;
  if(yy<0)yy=0;
  if(x>639)x=639;
  if(xx>639)xx=639;
  if(y>479)y=479;
  if(yy>479)yy=479;
	for(cc=y;cc<=yy;cc++)
		{
		 d=cc*640+x;
		 z1=d;
		 z=(d>>16)&0x0007;
		 if(BANCO!=z)newbank(z);
		 pv=pvx+z1;
		 tt=0xFFFF-z1;
		 for(c=x;c<=xx;c++)
			{
			 *pv=INK;
			 pv++;
			 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
			 tt--;
			}
		base+=zz;
		}
;
}

/*  ------------------------------------------------
	Guarda una zona de la pantalla en la zona (n)
	xd,yd  cordendas de origen pantalla
	xs,ys  cordenadas de destino zona
	xx,yy  tamao de la zona
    ------------------------------------------------ */
void getz(int n,long xd,long yd,long xs,long ys, long xx, long yy)
{
int  d,d2;
unsigned short int c,cc,z,z1,zz,tt,x1,y1;
unsigned char *base;
int ancho,alto;
	base=grafi[n];
	if(base==0) goto getfin;
	ancho=*base;
	base++;
	z=*base; ancho+=(z<<8);
	base++;
	alto=*base;
	base++;
	z=*base; alto+=(z<<8);
	base++;
	if(xs+xx>ancho || ys+yy>alto) goto getfin;
	d2=xs+(ancho*ys);  base+=d2;

	x1=xd+xx; y1=yd+yy;
	zz=ancho-xx;

	for(cc=yd;cc<y1;cc++)
		{
		 d=cc*640+xd;
		 z1=d;
		 z=(d>>16)&0x0007;
		 if(BANCO!=z)newbank(z);
		 pv=pvx+z1;
		 tt=0xFFFF-z1;
		for(c=xd;c<x1;c++)
			{
			 *base=*pv;
			 base++; pv++;
			 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
			 tt--;
			}
		base+=zz;
		}

getfin:
;
}

/*  ----------------------------------------------------
	imprime una una parte de la zona (n) en pantalla
	xd,yd  cordendas de destino
	xs,ys  cordenadas de fuente
	xx,yy  tamao de la zona
    ----------------------------------------------------*/
void putz(int n,long xd,long yd,long xs,long ys, long xx, long yy)
{
int  d,d2;
unsigned short int c,cc,z,z1,zz,tt,x1,y1;
unsigned char *base;
int ancho,alto;
unsigned char ma;
	base=grafi[n];
	if(base==0) goto putfin;
	ancho=*base;
	base++;
	z=*base; ancho+=(z<<8);
	base++;
	alto=*base;
	base++;
	z=*base; alto+=(z<<8);
	base++;
	d2=xs+(ancho*ys);  base+=d2;
	x1=xd+xx; y1=yd+yy;
	zz=ancho-xx;
	if(SETIM>255)
	 {
	  ma=SETIM&255;
	  for(cc=yd;cc<y1;cc++)
		{
		 d=cc*640+xd;
		 z1=d;
		 z=(d>>16)&0x0007;
		 if(BANCO!=z)newbank(z);
		 pv=pvx+z1;
		 tt=0xFFFF-z1;
		for(c=xd;c<x1;c++)
			{
			 if(ma!=*base)*pv=*base;
			 base++; pv++;
			 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
			 tt--;
			}
		base+=zz;
		}
	 }
	 else
	 {
	  for(cc=yd;cc<y1;cc++)
		{
		 d=cc*640+xd;
		 z1=d;
		 z=(d>>16)&0x0007;
		 if(BANCO!=z)newbank(z);
		 pv=pvx+z1;
		 tt=0xFFFF-z1;
		for(c=xd;c<x1;c++)
			{
			 *pv=*base;
			 base++; pv++;
			 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
			 tt--;
			}
		base+=zz;
		}
	}
putfin:
;
}
/* ---- lee una imagen *.pcx a un bloque nuevo ---- */
void loadblock(int n,char *nombre)
{
unsigned short int x,xx,z,zz,cx,cy;
unsigned char a,b,verde,azul,rojo;
int  d,d1,d2,dd,me;
unsigned char *base;

	if ((pf=fopen(nombre,"rb"))==NULL) goto fin;
	x=fread(pal,128,1,pf);
	d1=1+pal[9]*256+pal[8];
	d2=1+pal[11]*256+pal[10];
	me=d1*d2+4;
	if(grafi[n]!=0) free(grafi[n]);
	grafi[n]=malloc(me);
	if(grafi[n]==0){error(8); goto fin;}
	if(grafip[n]!=0) free(grafip[n]);
	grafip[n]=malloc(771);
	if(grafip[n]==0){error(8); goto fin;}
	me-=4;
	base=grafi[n];
	*base=d1&0x00FF;
	base++;
	*base=(d1>>8)&0x00FF;
	base++;
	*base=d2&0x00FF;
	base++;
	*base=(d2>>8)&0x00FF;
	base++;

while(1<2)
	{
	a=getc(pf);
	if(a>192){ b=a-192; a=getc(pf);} else {b=1;}
	while(b!=0){
		   b--;
		   *base=a;
		   base++;
		   me--;
		   if(me<1)goto salto;
		   }
	}

salto:
	x=fseek(pf,-768,2);
	x=fread(pal,769,1,pf);
	base=grafip[n];
	for (x=0;x<769;x++){ pal[x]=pal[x]/4; *base=pal[x]; base++;}
	fclose(pf);
fin:
;
}

/* ---- copia zona de pantalla a un bloque nuevo ---- */
void getblock(int n,int x,int y,int ancho,int alto)
{
unsigned short int c,cc,z,zz,tt,xx,yy;
unsigned int  me,d;
unsigned char *base;

	me=ancho*alto+4;
	if(grafi[n]!=0) free(grafi[n]);
	grafi[n]=malloc(me);
	if(grafi[n]==0){printc(0,0,"sin memoria"); goto getfin;}
	if(grafip[n]!=0) free(grafip[n]);
	grafip[n]=malloc(771);
	if(grafip[n]==0){printc(0,0,"sin memoria"); goto getfin;}
	base=grafi[n];
	*base=ancho&0x00FF;
	base++;
	*base=(ancho>>8)&0x00FF;
	base++;
	*base=alto&0x00FF;
	base++;
	*base=(alto>>8)&0x00FF;
	base++;
	alto+=y; ancho+=x;
	for(cc=y;cc<alto;cc++)
		{
		d=cc*640+x;
		zz=d;
		z=(d>>16)&0x0007;
		if(BANCO!=z)newbank(z);
		pv=pvx+zz;
		tt=0xFFFF-zz;
		for(c=x;c<ancho;c++)
			{
			 *base=*pv;
			 base++; pv++;
			 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
			 tt--;
			}
		}
	base=grafip[n];
	for (x=0;x<769;x++){ *base=pal[x]; base++;}
 getfin:
 ;
}
/* ---- copia un bloque a las coordenas x,y de la pantalla ---- */
void putblock(int n,int x,int y)
{
unsigned int  d;
unsigned short int c,cc,z,tt,zz;
unsigned char *base;
unsigned short int ancho,alto;

	base=grafi[n];
	if(base==0) goto putfin;
	ancho=*base;
	base++;
	z=*base; ancho+=(z<<8);
	base++;
	alto=*base;
	base++;
	z=*base; alto+=(z<<8);
	base++;
	alto+=y; ancho+=x;
	for(cc=y;cc<alto;cc++)
		{
		d=cc*640+x;
		zz=d;
		z=(d>>16)&0x0007;
		if(BANCO!=z)newbank(z);
		pv=pvx+zz;
		tt=0xFFFF-zz;
		for(c=x;c<ancho;c++)
			{
			 *pv=*base;
			 base++; pv++;
			 if(tt==0){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
			 tt--;
			}
		}
putfin:
;
}


/* ---- lee una imagen en pantalla coordenadas CX,CY --- */
void loadpcx(char *nombre)
{
unsigned short int x,xx,z,zz,cx,cy,tt;
unsigned char a,b,verde,azul,rojo;
unsigned int d,d1,d2,dd;

if ((pf=fopen(nombre,"rb"))==NULL) goto fin;

	for (x=0;x<769;x++) pal[x]=0;
	paletapal();
	x=fread(pal,128,1,pf);

	cx=CX; cy=CY;

	d1=1+pal[9]*256+pal[8];

	d2=1+pal[11]*256+pal[10];
	if(d1&1==1)d1++;
	d=d1*d2;
	xx=CX+d1;
	dd=cy*640+cx;
	z=(dd>>16)&0x0007;
	if(BANCO!=z)newbank(z);
	pv=pvx+dd;
	tt=0xFFFF-dd;
	while(1<2)
	 {
	  a=getc(pf);

	  if(a>192){ b=a-192; a=getc(pf);} else {b=1;}

	  while(b!=0)
	  	  {
		   b--;
		   *pv=a;
		   pv++;
		   if(tt==0){ newbank(BANCO+1); tt=0xFFFF;pv=pvx;}
		   tt--; cx++;
		   if(cx>=xx)

			{
			 cx=CX; cy++;
			 dd=cy*640+cx;
			 zz=dd;
			 z=(dd>>16)&0x0007;
			 if(BANCO!=z)newbank(z);
			 pv=pvx+zz;
			 if(pv>pvm)pv=pvx+(pv-pvm)-1;
			 tt=0xFFFF-dd;
			}
		   d--;
		   if(d<1)goto salto;
		  }
	 }
salto:
	x=fseek(pf,-768,2);
	x=fread(pal,769,1,pf);
	for (x=0;x<769;x++) pal[x]=pal[x]>>2;
	paletapal();
	fclose(pf);
fin:
;
}


/*---- IMPRIME CARACTER ----*/
void impri (int x,int y,unsigned char ca)
{

unsigned short int tt;
unsigned short int z,zz,z1,zz1,z2,zz2;
unsigned char n,c;
int d,d1;

	zz=ca*8;
	d1=y*640;
if(FONTX==1 && FONTY==1)
  {
  	d=d1+x;
	z1=(d>>16)&0x0007;
	zz1=d;
	if(BANCO!=z1);	newbank(z1);
	pv=pvx+zz1;
	tt=0xFFFF-zz1;
	for(z=zz;z<zz+8;z++)
	 {
	  n=tabla[z];
	  for (c=0;c<8;c++)
	   {
		if(n&128) { *pv=INK;} else { *pv=PAPER;} 
		pv++; tt--;
		if(tt<1){ newbank(BANCO+1); tt=0xFFFF; pv=pvx;}
		n=n<<1;
	   }
	  pv+=632;
	  if(pv>pvm)pv=pvx+(pv-pvm)-1;
	  if(tt<632){ newbank(BANCO+1); tt=0xFFFF;}
	  tt-=632;
	  if(tt<1){ newbank(BANCO+1); tt=0xFFFF;}
	 }
  }
  else
  {
   for(z=zz;z<zz+8;z++)
	 {
	  for(zz2=FONTY;zz2>0;zz2--)
	   {
		  n=tabla[z];
		  for (c=0;c<8;c++)
		   {
			for(z2=FONTX;z2>0;z2--)
			 {
			  d=d1+x;
			  z1=(d>>16)&0x0007;
			  zz1=d;
			  if(BANCO!=z1)newbank(z1);
			  pv=pvx+zz1;
			  if(n&128)	 { *pv=INK;} else { *pv=PAPER;}
			  x++;
			 }
			n=n<<1;
		   }
		 x+=640-(FONTX<<3);
		}
	 }
  }
}
/* lee punto de pantalla */
int point(int x,int y)
{
int d;
unsigned short int z,zz;
	d=y*80;	d<<=3;	d+=x;
	z=(d>>16)&0x0007;
	zz=d;
	if(BANCO!=z)newbank(z);
	pv=pvx+zz;
	return(*pv);
}
/* imprime punto */
void plot(int x,int y)
{
int d;
unsigned short int z,zz;
	d=y*80;	d<<=3;	d+=x;
	z=(d>>16)&0x0007;
	zz=d;
	if(BANCO!=z)newbank(z);
	pv=pvx+zz;
	*pv=INK;
}
/* ---BORRA PANTALLA ---- */
void clear(unsigned char c)
{
unsigned int x,z;
	for(z=0;z<5;z++)
	{pv=pvx; newbank(z); for(x=0;x<=0xffff;x++,pv++)*pv=c;}
}
/* ---LINEA --------------*/
void line(int x,int y,int xx,int yy)
{
 int d;
 unsigned short int z,zz,c,a,vx,vy;

 if(x==xx)
	{
	 if(y>yy){z=y;y=yy;yy=z;}
	 if(y<0) y=0;
	 if(yy>480)yy=480;
	 for(;y<=yy;y++)plot(x,y);
	 goto fin;
	}

 if(y==yy)
	{
     if(x>xx){d=x;x=xx;xx=d;}
	 if(x<0)x=0;
	 if(xx>639)xx=639;
	 d=y*640;
	 z=(d>>16)&0x0007;
	 zz=d+x;
	 if(BANCO!=z)newbank(z);
	 pv=pvx+zz;
	 z=xx-x; z++;
	 for(;z>0&&pv<pvm;z--,pv++) *pv=INK;
	 if(pv>=pvm)for(;x<=xx;x++)plot(x,y);
	 goto fin;
	}
 if(x<xx)
	if(y<yy)
		 goto normal;
	   else
		 goto nonormal;
 if(x>xx)
	if(y>yy)

		{

		 z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto normal;

		}

	   else

		{

		 z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto nonormal;

		}

nonormal:

	 vx=xx-x; vy=y-yy;a=0;

	 plot(xx,yy);

	 if(vx>vy)

		{

		 c=vx;

		 while(c>0)

			{

			 c--;xx--;a+=vy;

			 if(a>=vx){a-=vx; yy++;}

			 plot(xx,yy);

			}

		}

	   else

		{

		 c=vy;

		 while(c>0)

			{

			 c--;yy++;a+=vx;

			 if(a>=vy){a-=vy;xx--;}

			 plot(xx,yy);

			}

		}

 goto fin;

normal:

	 vx=xx-x;vy=yy-y;a=0;

	 plot(x,y);

	 if(vx>vy)

		{

		 c=vx;

		 while(c>0)

			{

			 c--; x++; a=a+vy;

			 if(a>=vx){ a-=vx; y++; }

			 plot(x,y);

			}

		}

		else

		{

		 c=vy;

		 while(c>0)

			{

			 c--; y++; a=a+vx;

			 if(a>=vy){ a-=vy; x++; }

			 plot(x,y);

			}

		}

fin:
;
}


/* ---- num<1 aclara-- num>1 oscurece ---num entre 1 y 5 - */
void fade(int num)
{
int z,zz,x,nu,f1;
int pal1[769];
  f1=Ctime();
  for(x=0;x<769;x++) pal1[x]=pal[x];

  if(num>0)
   {
	nu=70-num*13;
	for(z=0;z<nu;z++)
	   {
		for(zz=0;zz<769;zz++) 
			if(pal[zz]>num)pal[zz]-=num; else pal[zz]=0;
		paletapal();
		while(f1==(Ctime()/6));
		f1=(Ctime()/6);
	   }
	 for(x=0;x<769;x++) pal[x]=0;
	 paletapal();
	 for(x=0;x<769;x++) pal[x]=pal1[x];
	}
     else
	{
	num=num*-1;
	for(z=70;z>10;z-=num)
	   {
		for(zz=0;zz<769;zz++) 
			if(pal1[zz]-z>0) pal[zz]=pal1[zz]-z; else pal[zz]=0; 
		paletapal();
		while(f1==Ctime()/6);
		f1=Ctime()/6;
	   }
	 for(x=0;x<769;x++) pal[x]=pal1[x];
	 paletapal();
	}
}

/* ---- devuelve tiempo del sistema ---- */
unsigned int Ctime(void)
{
struct timeval tv;
unsigned int z,zz;
	gettimeofday(&tv,NULL);
	z=tv.tv_usec/10000;
	zz=(tv.tv_sec & 0x00fff)*100;
	return(zz+z);
}

/* --- Coloca los colores definidos en tleta en la cadena COLOR --- */
void getcolors(void)
{
int x,z,zz;
char xr,xv,xa;
 for(x=0;x<16;x++)
	{
	 zz=x*3; xr=tleta[zz]; xv=tleta[zz+1]; xa=tleta[zz+2];
	 for(z=0;z<766;z+=3)
		{
		 if(pal[z]==xr && pal[z+1]==xv && pal[z+2]==xa)
			{ COLOR[x]=z/3; goto salto;}
		}
	 COLOR[x]=254;
salto:
;
	}
}
/* ------MOUSE ------ */
/*  3-carga datos */
void mouse(int x)
{
	if(x==3 || x==9)
	 {
		mouse_update();
		XMOUSE = mouse_getx();
		YMOUSE = mouse_gety();
		KMOUSE = mouse_getbutton();
		if(KMOUSE==1)KMOUSE=2;
		if(KMOUSE==4)KMOUSE=1;
		CMOUSE=0;
		if(MXz!=XMOUSE || MYz!=YMOUSE || MKz!=KMOUSE) CMOUSE=1;
		MXz=XMOUSE; MYz=YMOUSE; MKz=KMOUSE;
	 }
}

void velocidad(void)
{
long Sti;
unsigned ti;
	Sti=0;
	printc(0,0,"ESPERA UN MOMENTO");
	ti=time(NULL);
	while(ti==time(NULL));
	ti=time(NULL);
	while(ti==time(NULL))Sti++;
	SPEED=Sti/1000;
}
/* ---- espera s segundos ---- */
void waits(int s)
{
int z;
	z=s*100;
	z+=(Ctime());
 	while(Ctime()<z);
}
/* ---- devuelve la tecla pulsada ---- */
int inkey2(void)
{
int c,z,zz,t;
struct timeval timeout;
fd_set read_fds;

	FD_ZERO (&read_fds);
	FD_SET (0, &read_fds);
	timeout.tv_sec = 0;
	timeout.tv_usec = 0;
	switch (select (1,&read_fds,(fd_set*)NULL,(fd_set*)NULL, &timeout))
	 {
	  case 0:
	  	 c=0; t=0;
	  	 break;
	  default:
		 read(0,&c,1);
                 c&=255; t=0;
                 switch(c)
                    {
                     case 42:
                        sfteclado=1; break;
                     case 54:
                        sfteclado=1; break;
                     case 58:
                        if(bmteclado==0) bmteclado=1; else bmteclado=0;
                        break;
                     case 69:
                        if(nuteclado==0) nuteclado=1; else nuteclado=0;
                        break;
                     case 100:
                        agteclado=1; break;
                     case 170:
                        sfteclado=0; break;
                     case 182:
                        sfteclado=0; break;
                     case 228:
                        agteclado=0; break;
                     default:
                        if(c&128) break;
                        z=c&0x007f;
                        if(z>101 && z<112){ t=0; c=m2teclado[z]; break;}
                        if(sfteclado==0)t=m0teclado[z]; else t=m1teclado[z];
                        if(agteclado==1)t=m2teclado[z];
                        if(nuteclado==1 && z>70 && z<84) t=m2teclado[z];
                        if(bmteclado==1 && t>96 && t<123) t-=32;
                        break;
                    }
                 c=c<<8; c=c|t;
		 break;
	 }       
	return(c&0x00FFFF);
}
/* ---- devuelve la tecla pulsada ---- */
int inkey(void)
{
    return(inkey2()&255);
}
/* ---- devuelve el modo de pantalla ---- */
int dmode(void)
{
     return(vga_getcurrentmode());
}
/* ---- modo de pantalla ---- */
void mode(int mode_code)
{
 if(mode_code!=10)
 	{
 	 free(VARI0);
         keyboard_close();
 	 if(MOUSE==1)
 	  {
 	    #ifdef MANUALLY_SETUP_MOUSE
    		mouse_close();
	    #endif 
	  }
 	 vga_setmode(TEXT);
 	}
 	else
 	{
 	 VARI0=malloc(5000);
/* 	 vga_init();   	 */

   	 vga_setmode(G640x480x256);
	 gl_setcontextvga(G640x480x256);
      	 gl_enableclipping();

    	 if(MOUSE==1)
    	 {
    	   vga_setmousesupport(1);   
    	   if ((mouse_init("/dev/mouse", vga_getmousetype(), 10)) != 0) 
    		{
	 	 printf("El raton no puede funcionar\n");
  		}
  	 }
  	 keyboard_init();
	 mouse_setxrange(0, WIDTH - 1);
	 mouse_setyrange(0, HEIGHT - 1);
	 mouse_setposition(320,200);
  	 pvx=VBUF; pvm=pvx+0xffff; 
       }
 
}
/*---- coloca paleta por defecto ----*/
void paleta()
{
 int z;
	pvi=VARI0; 
	 pvi1=pvi;
 	 for(z=0;z<48;z++){ *pvi1=tleta[z]; pvi1++; }
 	 vga_setpalvec(0,16,pvi);
}
/* ---- coloca la paleta situada en la variable pal ---- */
void paletapal(void)
{
int z;
	pvi=VARI0;
	 pvi1=pvi;
 	 for(z=0;z<769;z++){ *pvi1=pal[z];  pvi1++;}
 	 vga_setpalvec(0,256,pvi);
}
/* ---- coloca la paleta del bloque n --- */
void paletablock(int n)
{
unsigned char *base;
int x;
	base=grafip[n];
	for (x=0;x<769;x++){  pal[x]=*base; base++;}
	paletapal();
}
/* ----IMPRIME CADENA ---*/
void printc(int x,int y,char *texto)
{
unsigned char z;
	for(z=0;z<40 && texto[z]!=0;z++){ impri(x,y,texto[z]); x+=8*FONTX;}
}
/* ---- IMPRIME NUMERO ----*/
void printn(int x,int y,long num)
{
int z;
 for(z=0;z<40;z++)VARI[z]=0;
 sprintf(VARI,"%d",num);
 printc(x,y,VARI);
}

/* ---- CARGA FONTS -------*/

void loadfont(char *nombre)
{
 int x;
 if((pf=fopen(nombre,"rb"))==NULL)
	 {
	  /* pv=0xFFA6000E; */
	  for(x=0;x<2040;x++){tabla[x]=*pv; pv++;}
	 }
	else
	 {
	  x=fread(VARI,1,1,pf);
	  if(VARI[0]=='S')
			{
			 x=fread(VARI+1,9,1,pf);
			 x=fread(tabla,2040,1,pf);
			}
		else
			{
			 tabla[0]=VARI[0];
			 x=fread(tabla+1,2040,1,pf);
			}
	  fclose(pf);
	 }
}

void box(int x,int y,int xx,int yy)
{
	line(x,y,xx,y);
	line(xx,y,xx,yy);
	line(xx,yy,x,yy);
	line(x,yy,x,y);
}
/* ------ Tratamiento de errores ----- */
void error(int z)
{
	switch(z)
		{
		 case 2:
			printc(0,0,"Fichero no encontrado");
			break;
		 case 8:
			printc(0,0,"Memoria insuficiente");
			break;
		 case 13:
			printc(0,0,"Dato invalido");
			break;
		 default:
			printc(0,0,"Error desconocido");
			break;
		}
}

/* ---- LEE CADENA DEL TECLADO ----*/
void inputc(int x,int y,char *nombre)
{
int z,zz,n;
	printc(x,y,nombre);
	pv=nombre;
	for(z=0;z<79;z++){ if(*pv==0)break;  pv++;} 
	x+=((z<<3)*FONTX); z=x; n=0; zz=0;
	while(zz!=10)
		{
		 zz=inkey();
		 if(zz==13 || zz==27) goto fin;
		 if(zz!=0)
			{
			 if(zz==8)
			  { if(n!=0){z-=(8*FONTX);n--;impri(z,y,32);} }
			  else
			  { impri(z,y,zz); if(n<38){z+=(8*FONTX); VARI[n]=zz; n++;}}
			}
		}
fin:
	VARI[n]=0;
}

/* ---- LEE NUMERO DEL TECLADO ----*/
long inputn(int x,int y,char *nombre)
{
	inputc(x,y,nombre);
	return(atol(VARI));
}

